;
;  TOPPERS/SSP Kernel
;      Smallest Set Profile Kernel
; 
;  Copyright (C) 2014 by Naoki Saito
;             Nagoya Municipal Industrial Research Institute, JAPAN
; 
;  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
;  Ai{\tgEFAς̂܂ށDȉjgpEEρE
;  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
;  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
;      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
;      R[hɊ܂܂Ă邱ƁD
;  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
;      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
;      jAȂǁjɁCL̒쌠\C̗pщL̖
;      ؋Kfڂ邱ƁD
;  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
;      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
;    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
;        \C̗pщL̖ۏ؋Kfڂ邱ƁD
;    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
;        邱ƁD
;  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
;      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
;      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
;      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
; 
;  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
;  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
;  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
;  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
;  ȂD
; 
; 

;
; X^[gAbv[`
;    vZbTS2RAC~fBAfΏۂƂ
;

;
; O[oV{
;
	; ZOg擪AhX(segment_s.asm)
	extrn	_@R_INIT, _@R_INIS, _@RLINIT
	extrn	_@INIT, _@DATA, _@INIS, _@DATS, _@INITL, _@DATAL

	; ZOgAhX(segment_e.asm)
	extrn	_?R_INIT, _?R_INIS, _?RLINIT
	extrn	_?INIT, _?DATA, _?INIS, _?DATS, _?INITL, _?DATAL

	; X^bN|C^̏l(kernel_cfg.c)
	extrn	__kernel_istkpt
	
	; J[lJn(kernel/startup.c)
	extrn	_sta_ker
	
	; saddr̈̐擪AhXCTCYiJŒ`j
	extrn	_@SADBEG, _@SADSIZ
	
	; Gg|Cg
	public	_start


;
; 萔`
;
	; MAA(PMC̃rbg0): 0 ܂ 1
	;   0̏ꍇC00000H--0FFFFH  F0000H--FFFFFHփ~[
	;   1̏ꍇC10000H--1FFFFH  F0000H--FFFFFHփ~[
INIT_MAA	EQU	0

;
; }N`
;
	; ZOgԂ̃f[^Rs[(farROMnearRAMցCsrc̃TCY)
copy_seg	macro src, dst
	local	_1, _2
	mov 	es, #highw	_@&src
	movw	hl, #loww	_@&src
	movw	de, #loww	_@&dst
	br  	$_2
_1:
	mov 	a, es:[hl]
	mov 	[de], a
	incw	hl
	incw	de
_2:
	movw	ax, hl
	cmpw	ax, #loww _?&src
	bnz 	$_1
	endm

	; ZOgԂ̃f[^Rs[(farROMfarRAMցCsrc̃TCY)
copy_fseg	MACRO	src, dst
	local	_1, _2
	movw	hl, #loww	_@&src
	movw	de, #loww	_@&dst
	br  	$_2
_1:
	mov 	es, #highw	_@&src
	mov 	a, es:[hl]
	mov 	es, #highw	_@&dst
	mov 	es:[de], a
	incw	hl
	incw	de
_2:
	movw	ax, hl
	cmpw	ax, #loww _?&src
	bnz 	$_1
	endm

	; ZOg̃f[^NA(near RAM)
clear_seg	MACRO	dst
	local	_1, _2
	mov 	es, #0fh
	movw	hl, #loww _@&dst
	movw	ax, #loww _?&dst
	br  	$_2
_1:
	mov 	[hl+0], #0
	incw	hl
_2:
	cmpw	ax, hl
	bnz 	$_1
	endm

	; ZOg̃f[^NA(far RAM)
clear_fseg	MACRO	dst
	local _1, _2
	mov 	es, #highw _@&dst
	movw	hl, #loww _@&dst
	movw	ax, #loww _?&dst
	br  	$_2
_1:
	mov 	es:[hl+0], #0
	incw	hl
_2:
	cmpw	ax, hl
	bnz 	$_1
	endm

;
; VXeJn
;
@@CODE	CSEG	BASE
_start:

	;
	; PSW̐ݒ
	;
    di          	; ݋֎~(݃bN̊݋֎~)
	sel 	rb0 	; WX^oN(RB0)
	
	;
	; ~[̈̐ݒ
	;
	mov 	a, #INIT_MAA
	mov1	cy, a.0
	mov1	maa, cy

	;
	; X^bN|C^̐ݒ
	;
	movw	de, #__kernel_istkpt
	mov 	es, #00H
	movw	ax, es:[de]
	movw	sp, ax

	;
	; _hardware_init_hook ̌Ăяo()
	;
	;call	!!_hardware_init_hook

	;
	; 
	;
	copy_seg	R_INIS, INIS
	copy_seg	R_INIT, INIT
	copy_fseg	RLINIT, INITL
	
	clear_seg	DATS
	clear_seg	DATA
	clear_fseg	DATAL

	;  saddr̈̏
	mov	b,#_@SADSIZ
	clrw	ax
saddr_init_loop:
	dec	b
	dec	b
	movw	_@SADBEG[b], ax
	bnz	$saddr_init_loop

	;
	; _sofrware_init_hook ̌Ăяo()
	;
	;call	!!_software_init_hook
	
	;
	; sta_ker (kernel/startup.c) ̌Ăяo
	;
	br	!!_sta_ker

_loop:
	br	$_loop

	END
